Package ghidra.util.database.spatial.hyper

# Class AbstractHyperRStarTree<P extends HyperPoint,DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<P,NS>,NR extends DBTreeNodeRecord<NS>,T,Q extends AbstractHyperBoxQuery<P,DS,NS,Q>>

java.lang.Object
ghidra.util.database.spatial.AbstractConstraintsTree<DS,DR,NS,NR,T,Q>
ghidra.util.database.spatial.AbstractRStarConstraintsTree<DS,DR,NS,NR,T,Q>
ghidra.util.database.spatial.hyper.AbstractHyperRStarTree<P,DS,DR,NS,NR,T,Q>

Direct Known Subclasses:
  `DBTraceObjectValueRStarTree`

public abstract class AbstractHyperRStarTree<P extends HyperPoint,DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<P,NS>,NR extends DBTreeNodeRecord<NS>,T,Q extends AbstractHyperBoxQuery<P,DS,NS,Q>> extends AbstractRStarConstraintsTree<DS,DR,NS,NR,T,Q>

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected static class`
  `AbstractHyperRStarTree.AsSpatialMap<DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<?,NS>,T,Q extends AbstractHyperBoxQuery<?,DS,NS,Q>>`

  ## Nested classes/interfaces inherited from class ghidra.util.database.spatial.AbstractRStarConstraintsTree

  `AbstractRStarConstraintsTree.LeastAreaEnlargementThenLeastArea, AbstractRStarConstraintsTree.LeastDistanceFromCenterToPoint, AbstractRStarConstraintsTree.LevelInfo`

  ## Nested classes/interfaces inherited from class ghidra.util.database.spatial.AbstractConstraintsTree

  `AbstractConstraintsTree.TreeRecordVisitor, AbstractConstraintsTree.VisitResult`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final List<Comparator<NS>>`
  `axes`
  `protected final EuclideanHyperSpace<P,NS>`
  `space`

  ### Fields inherited from class ghidra.util.database.spatial.AbstractRStarConstraintsTree

  `CHEAT_OVERLAP_COUNT, FILL_RATE, MAX_LEVELS, maxChildren, minChildren, REINSERT_RATE, reinsertCount`

  ### Fields inherited from class ghidra.util.database.spatial.AbstractConstraintsTree

  `cachedDataChildren, cachedNodeChildren, dataStore, leafLevel, nodeStore, root`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractHyperRStarTree(DBCachedObjectStoreFactory storeFactory, String tableName, EuclideanHyperSpace<P,NS> space, Class<DR> dataType, Class<NR> nodeType, boolean upgradeable, int maxChildren)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AbstractConstraintsTreeSpatialMap<DS,DR,NS,T,Q>`
  `asSpatialMap()`
  `protected <V> Comparator<NS>`
  `dimComparator(Dimension<V,P,NS> dim)`
  `protected Comparator<NS>`
  `getDefaultBoundsComparator()`
  `protected List<Comparator<NS>>`
  `getSplitAxes()`

  ### Methods inherited from class ghidra.util.database.spatial.AbstractRStarConstraintsTree

  `checkNodeIntegrity, computeOverlap, doChooseSplitAxis, doChooseSplitIndex, doChooseSubtree, doInsert, doInsertData, doOverflowTreatment, doReInsert, doSplit, findChildByMinimumEnlargementCost, findChildByNearlyMinimumOverlapCost`

  ### Methods inherited from class ghidra.util.database.spatial.AbstractConstraintsTree

  `checkDataIntegrity, checkIntegrity, clear, computeLeafLevel, count, createDataEntry, createNodeEntry, destroySubtree, doAddToCachedChildren, doDecrementDataCount, doDeleteEntry, doFindExact, doRecomputeBounds, doRemoveData, doRemoveFromCachedChildren, doSetParentKey, doUnparentEntry, doUpdateOrDeleteAlongPath, dump, first, getChildrenOf, getDataByKey, getDataChildrenOf, getDataChildrenOf, getNodeChildrenOf, getNodeChildrenOf, getOrCreateRoot, getParentOf, getUserIndex, init, invalidateCache, isEmpty, iterator, iterator, orderedIterator, resyncMetadata, unionStream, visit, visit, visitAllData`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### space

    protected final EuclideanHyperSpace<P extends HyperPoint,NS extends HyperBox<P,NS>> space

  - ### axes

    protected final List<Comparator<NS extends HyperBox<P,NS>>> axes

- ## Constructor Details

  - ### AbstractHyperRStarTree

    public AbstractHyperRStarTree(DBCachedObjectStoreFactory storeFactory, String tableName, EuclideanHyperSpace<P,NS> space, Class<DR> dataType, Class<NR> nodeType, boolean upgradeable, int maxChildren) throws VersionException, IOException
    Throws:
      `VersionException`
      `IOException`

- ## Method Details

  - ### dimComparator

    protected <V> Comparator<NS> dimComparator(Dimension<V,P,NS> dim)

  - ### getSplitAxes

    protected List<Comparator<NS>> getSplitAxes()
    Specified by:
      `getSplitAxes` in class `AbstractRStarConstraintsTree<DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<P,NS>,NR extends DBTreeNodeRecord<NS>,T,Q extends AbstractHyperBoxQuery<P,DS,NS,Q>>`

  - ### getDefaultBoundsComparator

    protected Comparator<NS> getDefaultBoundsComparator()
    Specified by:
      `getDefaultBoundsComparator` in class `AbstractConstraintsTree<DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<P,NS>,NR extends DBTreeNodeRecord<NS>,T,Q extends AbstractHyperBoxQuery<P,DS,NS,Q>>`

  - ### asSpatialMap

    public AbstractConstraintsTreeSpatialMap<DS,DR,NS,T,Q> asSpatialMap()
    Specified by:
      `asSpatialMap` in class `AbstractConstraintsTree<DS extends BoundedShape<NS>,DR extends DBTreeDataRecord<DS,NS,T>,NS extends HyperBox<P,NS>,NR extends DBTreeNodeRecord<NS>,T,Q extends AbstractHyperBoxQuery<P,DS,NS,Q>>`